; Zadanie z predmetu Strojovo orientovane jazyky
; 12.1.2002 15:22

            .model      tiny
            .code

            org   100h

begin:      jmp   start


;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Procedury
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;******************************************************************************
; Vycistenie obrazovky a nastavenie farebneho textoveho modu cislo 3 
; 80x25 znakov
;------------------------------------------------------------------------------
set_mode3   proc  near
            mov   ax,0003h         ; ah - kod funkcie, al - cislo modu
            int   10h              ; vykonaj
            ret
set_mode3   endp

;******************************************************************************
; Nastavenie polohy kurzora na obrazovke
; Vstup: pozicia kurzora na adresach column a row
;------------------------------------------------------------------------------
cur_pos     proc  near
            mov   bh,0                    ; videostranka #0
            mov   ah,02h                  ; kod funkcie
            mov   dx,word ptr [column]    ; pozicia kurzora
            int   10h                     ; vykonaj
            ret
cur_pos     endp

;******************************************************************************
; Vypne zobrazenie kurzora v textovom rezime
;------------------------------------------------------------------------------
cur_off     proc  near
            mov   ah,01h           ; kod funkcie
            mov   cx,20h*256+00h   ; ch = 20h - vypnutie kurzora
            int   10h              ; vykonaj
            ret 
cur_off     endp

;******************************************************************************
; Zapne zobrazenie kurzora v textovom rezime
;------------------------------------------------------------------------------
cur_on      proc  near
            mov   ah,01h           ; kod funkcie
            mov   cx,13h*256+14h   ; velkost a tvar kurzora
            int   10h              ; vykonaj
            ret
cur_on      endp

;******************************************************************************
; Zobrazenie jedneho znaku na poziciu kurzora a posun kurzora o jeden znak.
; Po dosiahnuti konca riadku sa kurzor posunie na dalsi riadok.
; Vstup: AL = znak
;------------------------------------------------------------------------------
put_char    proc  near
            mov   ah,09h                  ; kod funkcie
            mov   bh,0                    ; videostranka #0
            mov   bl,byte ptr [color]     ; farba
            mov   cx,1                    ; 1 znak
            int   10h                     ; zobraz znak
            inc   byte ptr [column]       ; posun kurzora doprava
            cmp   byte ptr [column],80    ; ak si nedosiahol koniec riadku
            jc    put_char_e              ; vrat sa cez nastavenie novej pozicie
            mov   byte ptr [column],0     ; vynuluj stlpec
            inc   byte ptr [row]          ; posun na dalsi riadok
            cmp   byte ptr [row],25       ; ak nie si na konci obrazovky
            jc    put_char_e              ; vrat sa cez nastavenie novej pozicie
            mov   byte ptr [row],0        ; vynuluj riadok
put_char_e: call  cur_pos                 ; nastav poziciu kurzora
            ret
put_char    endp

;******************************************************************************
; Zobrazenie horizontalnej linky po celej sirke riadku zo znaku "-"
; Vstup: BL = farba
;        DH = riadok
;------------------------------------------------------------------------------
prt_line    proc  near
            mov   byte ptr [color],bl     ; nastav farbu, ktorou sa bude pisat
            xor   dl,dl                   ; nastav kurzor na riadok,
            mov   word ptr [column],dx    ; kde bude linka
            call  cur_pos
            mov   cx,80                   ; sirka obrazovky
            mov   al,'-'
prt_line_l: push  cx                      ; a v cykle zobraz linku
            call  put_char
            pop   cx
            loop  prt_line_l
            ret
prt_line    endp

;******************************************************************************
; Zobrazenie textu na znakovu poziciu a farbou danymi pred textom.
; Vstup: SI = offsetova adresa textu
;        CX = dlzka samotneho textu
;------------------------------------------------------------------------------
prts_pos    proc  near
            cld
            lodsw                          ; vyber znakovu poziciu
            mov   word ptr [column],ax     ; a nastav kurzor
            call  cur_pos
            lodsb                          ; vyber farbu textu
            mov   byte ptr [color],al      ; a nastav ju
prts_pos_l: lodsb                          ; postupne vyberaj znaky
            push  cx                       ; kym nezobrazis cely text
            call  put_char
            pop   cx
            loop  prts_pos_l
            ret
prts_pos    endp

;******************************************************************************
; Zobrazenie textu na aktualnu poziciu kurzora farbou danou pred textom.
; Vstup: SI = offsetova adresa textu
;        CX = dlzka samotneho textu
;------------------------------------------------------------------------------
prt_str     proc  near
            cld
            lodsb                          ; vyber farbu textu
            mov   byte ptr [color],al      ; a nastav ju
prt_str_l:  lodsb                          ; postupne vyberaj znaky
            push  cx                       ; kym nezobrazis cely text
            call  put_char
            pop   cx
            loop  prt_str_l
            ret
prt_str     endp

;******************************************************************************
; Test klavesnice. Do uvahy sa beru len tlacitelne znaky s kodmi 32 az 126 a
; riadiace znaky Enter (0Dh) a BackSpace (08h).
;------------------------------------------------------------------------------
get_key     proc  near
get_key_l:  xor   ax,ax               ; otestuj klavesnicu
            int   16h                 ; al = kod stlacenej klavesy
            cmp   al,27               ; Escape sa bude brat
            jnz   get_key_e
            mov   al,13               ; ako Enter
get_key_e:  cmp   al,13               ; Enter
            jz    get_key_r
            cmp   al,8                ; BackSpace
            jz    get_key_r
            cmp   al,32
            jc    get_key_l
            cmp   al,127
            jnc   get_key_l
get_key_r:  ret
get_key     endp

;******************************************************************************
; Vypocet adresy v bufri kam ukazuje kurzor.
; Vystup: Adresa v ES:DI
;------------------------------------------------------------------------------
buff_adr    proc  near
            mov   bx,ds                    ; pre istotu skopiruj DS do ES
            mov   es,bx
            mov   di,offset buffer         ; a do DI daj adresu buffra
            xor   bh,bh
            mov   bl,byte ptr [column]     ; posun sa v buffri na miesto
            add   di,bx                    ; kam ukazuje kurzor
            ret
buff_adr    endp

;******************************************************************************
; Procedura zabezpecujuca editaciu textu v riadku.
; Vstup:  DH = riadok
; Vystup: text v buffri ukonceny cislom 255
;         pocet znakov v bufri je na adrese column
;------------------------------------------------------------------------------
edit        proc  near
            cld
            xor   dl,dl                      ; nastav kurzor na riadok,
            mov   word ptr [column],dx       ; v ktorom sa ma editovat
            call  cur_pos
            mov   ax,ds
            mov   es,ax
            mov   di,offset buffer           ; vyprazni buffer
            mov   al,32
            mov   cx,80
            rep   stosb
            mov   byte ptr [color],7         ; farba pisaneho textu
edit_loop:  call  get_key
            call  buff_adr                   ; v BL sa vrati aktualny stlpec
            cmp   al,13                      ; bol to Enter?
            jnz   edit_nent
            mov   byte ptr [di],255          ; ak to bol Enter ukonci buffer
            ret
edit_nent:  cmp   al,8                        ; bol to BackSpace?
            jz    edit_back                   ; ak to bol BackSpace, skoc dopr.
            cmp   bl,79                       ; moze sa napisat max. 79 znakov
            jz    edit_loop
            stosb                             ; uloz znak do buffra
            call  put_char                    ; a zobraz ho
            jmp   edit_loop
edit_back:  cmp   bl,0                        ; ak si na zaciatku riadka,
            jz    edit_loop                   ; nemas co zmazat
            mov   byte ptr [di - 1],32        ; vymaz znak z buffra
            dec   byte ptr [column]           ; posun kurzor do lava
            call  cur_pos
            mov   al,32                       ; zmaz znak z obrazovky
            call  put_char
            dec   byte ptr [column]           ; posun zase kurzor do lava,
            call  cur_pos                     ; pretoze ho posunula ta medzera
            jmp   edit_loop
edit        endp

;******************************************************************************
; Procedura pre vypisanie cisla v osmickovej sustave. Ak je cislo desiatkovo
; vacsie ako 63 vypise sa styroma znakmi (0135), inak troma (006).
; Vstup:  AL = vypisovane cislo
; Vystup: zobrazenie cisla na aktualnej znakovej pozicii
;------------------------------------------------------------------------------
prt_oct     proc  near
            mov   bl,al                  ; zobrazovane cislo do BL
            mov   al,byte ptr [txt22]    ; farbu cisel podla textu " krat"
            mov   byte ptr [color],al
            cmp   bl,64                  ; ak je to cislo vacsie ako 63,
            jc    prt_oct2
            push  bx
            mov   al,'0'                 ; zobraz najprv '0'
            call  put_char
            pop   bx
prt_oct2:   mov   bh,64                   ; najvissi rad 8^2 = 64
            call  digit                   ; odpocitaj rad a zobraz cislicu
            mov   bh,8                    ; dalsi rad 8^1 = 8
            call  digit                   ; odpocitaj rad a zobraz cislicu
            mov   bh,1                    ; najnizsi rad 8^0 = 1
            call  digit                   ; odpocitaj rad a zobraz cislicu
            mov   si,offset txt22         ; zobraz text " krat"
            mov   cx,txt22len
            jmp   prt_str
digit:      mov   al,'0' - 1              ; bez jednej kvoli nasl. instr.
digit2:     inc   al                      ; zvacsi cislicu
            sub   bl,bh                   ; skus urobit odpocet radu
            jnc   digit2                  ; ak sa to podarilo, skus znovu
            add   bl,bh                   ; ak nie, vrat predoslu hodnotu
            push  bx
            call  put_char                ; a vytlac cislicu
            pop   bx
            ret
prt_oct    endp

;******************************************************************************
; Procedura najde dalsie slovo v buffri.
; Vstup:  DS:SI = adresa v buffri
; Vystup: CY = 0 - naslo sa slovo a v
;         DS:SI = adresa dalsieho slova v buffri
;         CY = 1 - dosiahol sa koniec buffra
;------------------------------------------------------------------------------
find_word  proc  near
           dec   si                    ; posun sa na predosly znak v buffri
find_wrd2: lodsb                       ; a hladaj koniec slova
           cmp   al,255                ; ak si dosiel na koniec buffra
           jz    buf_end               ; skonci to
           cmp   al,32                 ; je to koniec slova ?
           jnz   find_wrd2
find_wrd3: lodsb                       ; preskoc vsetky medzery, aby si nasiel
           cmp   al,255                ; dalsie slovo
           jz    buf_end               ; pri konci buffra skonci
           cmp   al,32                 ; je to uz dalsie slovo
           jz    find_wrd3
           dec   si                    ; ak ano, posun sa spat na prve pismeno
           clc                         ; vynuluj Carry
           ret
buf_end:   stc                         ; nastav Carry - koniec buffra
           ret
find_word  endp

;******************************************************************************
; Procedura spocita v buffri pocet osmickovych cisel a ulozi ho na adresu
; (criteria + 0)
;------------------------------------------------------------------------------
crit1      proc  near
           mov   si,offset buffer         ; adresa buffra do SI
           mov   byte ptr [criteria],0    ; vynulj pocet slov
crit1_a:   call  find_word                ; najdi zaciatok slova. Ak si dosiel
           jc    crit1_end                ; na koniec bufra, ukonci proceduru
           lodsb                          ; vyber znak slova
           cmp   al,'0'                   ; osmickove slovo musi zacinat '0'
           jnz   crit1_a                  ; ak to nie je '0', ->dalsie slovo 
crit1_w:   lodsb                          ; kontrola dalsich znakov slova,
           cmp   al,255                   ; ktore sa mozu vyskytnut:
           jz    crit1_t                  ; 255 - koniec buffra
           cmp   al,' '                   ; ' ' - koniec slova
           jz    crit1_t
           cmp   al,'0'                   ; v osmickovej sustave mozu byt
           jc    crit1_a                  ; cislice 0 az 7
           cmp   al,'7' + 1
           jnc   crit1_a
           jmp   crit1_w
crit1_t:   inc   byte ptr [criteria]      ; ak slovo vyhovuje, zvys pocet slov
           cmp   al,255                   ; ak si nedosiahol koniec buffra,
           jnz   crit1_a                  ; vysetri dalsie slovo
crit1_end: ret
crit1      endp

;******************************************************************************
; Procedura spocita v buffri pocet celych desiatkovych cisel a ulozi ho na
; adresu (criteria + 1)
;------------------------------------------------------------------------------
crit2      proc  near
           mov   si,offset buffer
           mov   byte ptr [criteria + 1],0
crit2_a:   call  find_word
           jc    crit2_end
           lodsb
           mov   bh,0
           cmp   al,'0'
           jc    crit2_a
           jnz   crit2_i
           mov   bh,1
crit2_i:   cmp   al,'9' + 1
           jnc   crit2_a
           mov   bl,1
crit2_w:   lodsb
           cmp   al,255
           jz    crit2_t
           cmp   al,' '
           jz    crit2_t
           cmp   al,'0'
           jc    crit2_a
           cmp   al,'9' + 1
           jnc   crit2_a
           inc   bl
           jmp   crit2_w
crit2_t:   cmp   bl,0
           jz    crit2_s
           cmp   bh,1
           jnz   crit2_k
           cmp   bl,1
           jnz   crit2_s
crit2_k:   inc   byte ptr [criteria + 1]
crit2_s:   cmp   al,255
           jnz   crit2_a
crit2_end: ret
crit2      endp

;******************************************************************************
; Procedura spocita v buffri pocet sestnastkovych cisel a ulozi ho na
; adresu (criteria + 2)
;------------------------------------------------------------------------------
crit3      proc  near
           mov   si,offset buffer
           mov   [criteria + 2],0
crit3_a:   call  find_word
           jc    crit3_end
           lodsb
           cmp   al,'0'
           jnz   crit3_a
           lodsb
           cmp   al,'x'
           jz    crit3_x
           cmp   al,'X'
           jnz   crit3_a
crit3_x:   mov   bl,0
crit3_w:   lodsb
           cmp   al,255
           jz    crit3_t
           cmp   al,' '
           jz    crit3_t
           cmp   al,'0'
           jc    crit3_a
           cmp   al,'9' + 1
           jc    crit3_h
           cmp   al,'A'
           jc    crit3_a
           cmp   al,'F' + 1
           jc    crit3_h
           cmp   al,'a'
           jc    crit3_a
           cmp   al,'f' + 1
           jnc   crit3_a
crit3_h:   inc   bl
           jmp   crit3_w
crit3_t:   cmp   bl,0
           jz    crit3_s
           inc   byte ptr [criteria + 2]
crit3_s:   cmp   al,255
           jnz   crit3_a
crit3_end: ret
crit3      endp

;******************************************************************************
; Procedura spocita v buffri pocet desatinnych cisel a ulozi ho na
; adresu (criteria + 3)
;------------------------------------------------------------------------------
crit4      proc  near
           mov   si,offset buffer
           mov   [criteria + 3],0
crit4_a:   call  find_word
           jc    crit4_end
           mov   bx,0
           lodsb
           cmp   al,'.'
           jz    crit4_d
           cmp   al,'0'
           jc    crit4_a
           cmp   al,'9' + 1
           jnc   crit4_a
           inc   bl
           jmp   crit4_w
crit4_d:   inc   bh
crit4_w:   lodsb
           cmp   al,255
           jz    crit4_t
           cmp   al,' '
           jz    crit4_t
           cmp   al,'.'
           jz    crit4_d
           cmp   al,'0'
           jc    crit4_a
           cmp   al,'9' + 1
           jnc   crit4_a
           inc   bl
           jmp   crit4_w
crit4_t:   cmp   bl,0
           jz    crit4_s
           cmp   bh,1
           jnz   crit4_s
           inc   byte ptr [criteria + 3]
crit4_s:   cmp   al,255
           jnz   crit4_a
crit4_end: ret
crit4      endp

;******************************************************************************
; Procedura spocita v buffri pocet slov zlozenych len z pismen malej abecedy
; a ulozi ho na adresu (criteria + 4)
;------------------------------------------------------------------------------
crit5      proc  near
           mov   si,offset buffer
           mov   [criteria + 4],0
crit5_a:   call  find_word
           jc    crit5_end
           lodsb
           cmp   al,'a'
           jc    crit5_a
           cmp   al,'z' + 1
           jnc   crit5_a
crit5_w:   lodsb
           cmp   al,255
           jz    crit5_t
           cmp   al,' '
           jz    crit5_t
           cmp   al,'a'
           jc    crit5_a
           cmp   al,'z' + 1
           jnc   crit5_a
           jmp   crit5_w
crit5_t:   inc   byte ptr [criteria + 4]
           cmp   al,255
           jnz   crit5_a
crit5_end: ret
crit5      endp

;******************************************************************************
; Procedura spocita v buffri pocet slov zlozenych len z pismen velkej abecedy
; a ulozi ho na adresu (criteria + 5)
;------------------------------------------------------------------------------
crit6      proc  near
           mov   si,offset buffer
           mov   [criteria + 5],0
crit6_a:   call  find_word
           jc    crit6_end
           lodsb
           cmp   al,'A'
           jc    crit6_a
           cmp   al,'Z' + 1
           jnc   crit6_a
crit6_w:   lodsb
           cmp   al,255
           jz    crit6_t
           cmp   al,' '
           jz    crit6_t
           cmp   al,'A'
           jc    crit6_a
           cmp   al,'Z' + 1
           jnc   crit6_a
           jmp   crit6_w
crit6_t:   inc   byte ptr [criteria + 5]
           cmp   al,255
           jnz   crit6_a
crit6_end: ret
crit6      endp

;******************************************************************************
; Procedura spocita v buffri pocet slov zlozenych len z cislic
; a ulozi ho na adresu (criteria + 6)
;------------------------------------------------------------------------------
crit7      proc  near
           mov   si,offset buffer
           mov   [criteria + 6],0
crit7_a:   call  find_word
           jc    crit7_end
           lodsb
           cmp   al,'0'
           jc    crit7_a
           cmp   al,'9' + 1
           jnc   crit7_a
crit7_w:   lodsb
           cmp   al,255
           jz    crit7_t
           cmp   al,' '
           jz    crit7_t
           cmp   al,'0'
           jc    crit7_a
           cmp   al,'9' + 1
           jnc   crit7_a
           jmp   crit7_w
crit7_t:   inc   byte ptr [criteria + 6]
           cmp   al,255
           jnz   crit7_a
crit7_end: ret
crit7      endp

;******************************************************************************

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Hlavny program
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

start:      call  cur_off                 ; vypni kurzor 
            call  set_mode3               ; nastav mod 3 a zmaz obrazovku

            mov   si,offset txt01         ; adresa textu
            mov   cx,txt01len             ; jeho dlzka
            call  prts_pos                ; zobraz text od novej pozicie
            mov   si,offset txt02         ; adresa textu
            mov   cx,txt02len             ; jeho dlzka
            call  prt_str                 ; zobraz text od aktualnej pozicie
            mov   si,offset txt03         ; a znovu...
            mov   cx,txt03len
            call  prt_str
            mov   si,offset txt04
            mov   cx,txt04len
            call  prt_str

            mov   bl,15                   ; oddelovacia ciara
            mov   dh,1
            call  prt_line
;--------------------------------
            mov   si,offset txt05         ; popis programu
            mov   cx,txt05len
            call  prts_pos

            mov   si,offset txt06         ; jednotlive kriteria
            mov   cx,txt06len
            call  prts_pos
            mov   si,offset txt07
            mov   cx,txt07len
            call  prt_str

            mov   si,offset txt08
            mov   cx,txt08len
            call  prts_pos
            mov   si,offset txt09
            mov   cx,txt09len
            call  prt_str

            mov   si,offset txt10
            mov   cx,txt10len
            call  prts_pos
            mov   si,offset txt11
            mov   cx,txt11len
            call  prt_str

            mov   si,offset txt12
            mov   cx,txt12len
            call  prts_pos
            mov   si,offset txt13
            mov   cx,txt13len
            call  prt_str

            mov   si,offset txt14
            mov   cx,txt14len
            call  prts_pos
            mov   si,offset txt15
            mov   cx,txt15len
            call  prt_str

            mov   si,offset txt16
            mov   cx,txt16len
            call  prts_pos
            mov   si,offset txt17
            mov   cx,txt17len
            call  prt_str

            mov   si,offset txt18
            mov   cx,txt18len
            call  prts_pos
            mov   si,offset txt19
            mov   cx,txt19len
            call  prt_str

            mov   bl,15                   ; oddelovacia ciara
            mov   dh,11
            call  prt_line
;--------------------------------
            mov   si,offset txt20         ; "Zadaj text"
            mov   cx,txt20len
            call  prts_pos

            call  cur_on
            mov   dh,13                   ; editacia textu na riadku 13
            call  edit
            call  cur_off

            mov   bl,15                   ; oddelovacia ciara
            mov   dh,14
            call  prt_line
;--------------------------------
            cld                           ; spocitanie slov
            call  crit1                   ; na zaklade jednotlivych
            call  crit2                   ; kriterii
            call  crit3
            call  crit4
            call  crit5
            call  crit6
            call  crit7
;--------------------------------
            mov   si,offset txt21         ; zobrazenie vysledku hladania
            mov   cx,txt21len
            call  prts_pos

            mov   word ptr [column],1006h        ; osmickove cisla
            call  cur_pos
            mov   si,offset txt06 + 2
            mov   cx,txt06len
            call  prt_str
            mov   byte ptr [column],46
            call  cur_pos
            mov   al,[criteria]
            call  prt_oct

            mov   word ptr [column],1106h        ; desiatkove cisla
            call  cur_pos
            mov   si,offset txt08 + 2
            mov   cx,txt08len
            call  prt_str
            mov   byte ptr [column],46
            call  cur_pos
            mov   al,[criteria + 1]
            call  prt_oct

            mov   word ptr [column],1206h        ; sestnastkove cisla
            call  cur_pos
            mov   si,offset txt10 + 2
            mov   cx,txt10len
            call  prt_str
            mov   byte ptr [column],46
            call  cur_pos
            mov   al,[criteria + 2]
            call  prt_oct

            mov   word ptr [column],1306h        ; desatinne cisla
            call  cur_pos
            mov   si,offset txt12 + 2
            mov   cx,txt12len
            call  prt_str
            mov   byte ptr [column],46
            call  cur_pos
            mov   al,[criteria + 3]
            call  prt_oct

            mov   word ptr [column],1406h        ; len male pismena
            call  cur_pos
            mov   si,offset txt14 + 2
            mov   cx,txt14len
            call  prt_str
            mov   byte ptr [column],46
            call  cur_pos
            mov   al,[criteria + 4]
            call  prt_oct

            mov   word ptr [column],1506h        ; len velke pismena
            call  cur_pos
            mov   si,offset txt16 + 2
            mov   cx,txt16len
            call  prt_str
            mov   byte ptr [column],46
            call  cur_pos
            mov   al,[criteria + 5]
            call  prt_oct

            mov   word ptr [column],1606h        ; len cislice
            call  cur_pos
            mov   si,offset txt18 + 2
            mov   cx,txt18len
            call  prt_str
            mov   byte ptr [column],46
            call  cur_pos
            mov   al,[criteria + 6]
            call  prt_oct

            mov   bl,15                   ; oddelovacia ciara
            mov   dh,23
            call  prt_line
;--------------------------------
            mov   si,offset txt23         ; este raz zadanie ?
            mov   cx,txt23len
            call  prts_pos

ktest:      call  get_key                 ; test klaves A, N
            cmp   al,'a'
            jnz   ktest2
ktest3:     jmp   start
ktest2:     cmp   al,'A'
            jz    ktest3
            cmp   al,'n'
            jz    go_end
            cmp   al,'N'
            jnz   ktest            

go_end:     call  set_mode3               ; zmazanie obrazovky

            .exit                         ; to je koniec...


;------------------------------------------------------------------------------
; Vypisovane texty...
; Texty su vo formate: stlpec, riadok, farba textu, text
;               alebo: farba textu, text
;------------------------------------------------------------------------------
txt01       db   3, 0, 15
            db   'Program v '
txt01len    equ  $ - txt01 - 3
txt02       db   10
            db   'assembleri'
txt02len    equ  $ - txt02 - 1
txt03       db   15
            db   ' podla zadania z predmetu '
txt03len    equ  $ - txt03 - 1
txt04       db   14
            db   'Strojovo orientovane jazyky'
txt04len    equ  $ - txt04 - 1

txt05       db   3, 2, 2
            db   'Program nacita z klavesnice retazec znakov (maximalne 79'
            db   ' znakov) a osmickovo vypise pocty slov, ktore zodpovedaju'
            db   ' tymto kriteriam:'
txt05len    equ  $ - txt05 - 3

txt06       db   6, 4, 3
            db   '1. osmickove cislo'
txt06len    equ  $ - txt06 - 3
txt07       db   7
            db   ' (napr. 057)'
txt07len    equ  $ - txt07 - 1

txt08       db   6, 5, 3
            db   '2. desiatkove cislo'
txt08len    equ  $ - txt08 - 3
txt09       db   7
            db   ' (napr. 147)'
txt09len    equ  $ - txt09 - 1

txt10       db   6, 6, 3
            db   '3. sestnastkove cislo'
txt10len    equ  $ - txt10 - 3
txt11       db   7
            db   ' (napr. 0xB7)'
txt11len    equ  $ - txt11 - 1

txt12       db   6, 7, 3
            db   '4. desatinne cislo'
txt12len    equ  $ - txt12 - 3
txt13       db   7
            db   ' (napr. 3.14)'
txt13len    equ  $ - txt13 - 1

txt14       db   6, 8, 3
            db   '5. slovo zlozene len z malych pismen'
txt14len    equ  $ - txt14 - 3
txt15       db   7
            db   ' (napr. ahoj)'
txt15len    equ  $ - txt15 - 1

txt16       db   6, 9, 3
            db   '6. slovo zlozene len z velkych pismen'
txt16len    equ  $ - txt16 - 3
txt17       db   7
            db   ' (napr. NAZDAR)'
txt17len    equ  $ - txt17 - 1

txt18       db   6, 10, 3
            db   '7. slovo zlozene len z cislic'
txt18len    equ  $ - txt18 - 3
txt19       db   7
            db   ' (napr. 4593)'
txt19len    equ  $ - txt19 - 1

txt20       db   0, 12, 2
            db   'Zadaj retazec znakov:'
txt20len    equ  $ - txt20 - 3

txt21       db  3, 15, 4
            db  'V zadanom retazci sa nasli tieto pocty slov:'
txt21len    equ  $ - txt21 - 3

txt22       db  5
            db  ' krat'
txt22len    equ  $ - txt22 - 1

txt23       db   20, 24, 130
            db   'Chcete zadat dalsi retzec znakov ? (A/N)'
txt23len    equ  $ - txt23 - 3

;-------------------------
column     db   0
row        db   0
color      db   0
criteria   db   7  dup (0)      ; tu sa ukladaju pocty slov pre kriteria
space      db   ' '             ; Tato medzera pred buffrom tu musi byt!!!
buffer     db   80 dup (0)      ; Kvoli procedure find_word!

;-------------------------

            end  begin
